/// <reference types="amazon-cognito-identity-js" />
import { Observable } from 'rxjs';
interface IAuthService {
    signUp: (username: string, password: string, email: string, givenName: string, familyName: string) => Observable<any>;
    confirmSignUp: (username: string, code: string) => Observable<any>;
    signUpSuccessfulSignIn: (username: string, password: string, name: string) => Observable<any>;
    resendConfirmationCode: (username: string) => Observable<any>;
    signIn: (username: string, password: string) => Observable<any>;
    newPasswordRequired: (user: any, newPassword: string) => Observable<any>;
    signOut: () => Observable<any>;
    forgotPassword: (username: string) => Observable<any>;
    forgotPasswordSubmit: (username: string, code: string, password: string) => Observable<any>;
    changeAttributes: (email: string, name: string, id: number) => Observable<any>;
    changePassword: (user: any, oldPassword: string, newPassword: string) => Observable<string>;
}
declare class AuthService implements IAuthService {
    signUp: (username: string, password: string, email: string, givenName: string, familyName: string) => Observable<import("amazon-cognito-identity-js").ISignUpResult>;
    confirmSignUp: (username: string, code: string) => Observable<any>;
    signUpSuccessfulSignIn: (username: string, password: string) => Observable<any>;
    resendConfirmationCode: (username: string) => Observable<any>;
    newPasswordRequired: (user: any, newPassword: string) => Observable<any>;
    signIn: (username: string, password: string) => Observable<any>;
    signOut: () => Observable<any>;
    forgotPassword: (username: string) => Observable<any>;
    forgotPasswordSubmit: (username: string, code: string, password: string) => Observable<void>;
    changeAttributes: (email: string, name: string, guestId: number) => Observable<string>;
    changePassword: (oldPassword: string, newPassword: string) => Observable<"SUCCESS">;
}
declare const _default: AuthService;
export default _default;
