"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const aws_amplify_1 = require("aws-amplify");
const rxjs_1 = require("rxjs");
class AuthService {
    constructor() {
        this.signUp = (username, password, email, givenName, familyName) => rxjs_1.from(aws_amplify_1.Auth.signUp({
            'username': username,
            'password': password,
            'attributes': {
                'email': email,
                'given_name': givenName,
                'family_name': familyName,
            }
        }));
        this.confirmSignUp = (username, code) => rxjs_1.from(aws_amplify_1.Auth.confirmSignUp(username, code));
        this.signUpSuccessfulSignIn = (username, password) => rxjs_1.from(aws_amplify_1.Auth.signIn(username, password));
        this.resendConfirmationCode = (username) => rxjs_1.from(aws_amplify_1.Auth.resendSignUp(username));
        this.newPasswordRequired = (user, newPassword) => rxjs_1.from(aws_amplify_1.Auth.completeNewPassword(user, newPassword, {})).mergeMap(r => rxjs_1.from(aws_amplify_1.Auth.currentUserInfo()));
        this.signIn = (username, password) => rxjs_1.from(aws_amplify_1.Auth.signIn(username, password));
        this.signOut = () => rxjs_1.from(aws_amplify_1.Auth.signOut());
        this.forgotPassword = (username) => rxjs_1.from(aws_amplify_1.Auth.forgotPassword(username));
        this.forgotPasswordSubmit = (username, code, password) => rxjs_1.from(aws_amplify_1.Auth.forgotPasswordSubmit(username, code, password));
        this.changeAttributes = (email, name, guestId) => rxjs_1.from(aws_amplify_1.Auth.currentAuthenticatedUser()).mergeMap(user => rxjs_1.from(aws_amplify_1.Auth.updateUserAttributes(user, { email })));
        this.changePassword = (oldPassword, newPassword) => rxjs_1.from(aws_amplify_1.Auth.currentAuthenticatedUser()).mergeMap(user => rxjs_1.from(aws_amplify_1.Auth.changePassword(user, oldPassword, newPassword)));
    }
}
exports.default = new AuthService();
