"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useStatusData = exports.isAuthenticated = exports.useAuthDispatch = exports.AuthProvider = void 0;
const React = __importStar(require("react"));
const react_redux_1 = require("react-redux");
const dispatches_1 = __importDefault(require("./dispatches"));
const AuthContext = React.createContext(undefined);
function AuthProvider(props) {
    const dispatch = react_redux_1.useDispatch();
    const isAuthenticated = react_redux_1.useSelector((state) => state.authReducer.isAuthenticated);
    const status = react_redux_1.useSelector((state) => state.authReducer.status);
    const dispatches = dispatches_1.default(dispatch);
    return React.createElement(AuthContext.Provider, Object.assign({ value: { dispatches, isAuthenticated, status } }, props));
}
exports.AuthProvider = AuthProvider;
function useAuthDispatch() {
    const context = React.useContext(AuthContext);
    if (!context) {
        throw new Error('useAuthDispatch must be used within AuthProvider');
    }
    return context.dispatches;
}
exports.useAuthDispatch = useAuthDispatch;
function isAuthenticated() {
    const context = React.useContext(AuthContext);
    if (!context) {
        throw new Error('isAuthenticated must be used within AuthProvider');
    }
    return context.isAuthenticated;
}
exports.isAuthenticated = isAuthenticated;
function useStatusData() {
    const context = React.useContext(AuthContext);
    if (!context) {
        throw new Error('useStatusData must be used within AuthProvider');
    }
    return context.status;
}
exports.useStatusData = useStatusData;
