"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.changeAttributesAction = exports.changePasswordAction = exports.forgotPasswordSubmitAction = exports.forgotPasswordAction = exports.signOutAction = exports.signInAction = exports.resendConfirmationCodeAction = exports.confirmSignUpAction = exports.signUpAction = void 0;
const types_1 = require("./types");
function signUpAction({ email, password, firstName, lastName }) {
    return { type: types_1.AUTH_ACTION_TYPES.SIGN_UP, email, password, firstName, lastName };
}
exports.signUpAction = signUpAction;
function confirmSignUpAction(confirmationCode) {
    return { type: types_1.AUTH_ACTION_TYPES.CONFIRM_SIGN_UP, confirmationCode };
}
exports.confirmSignUpAction = confirmSignUpAction;
function resendConfirmationCodeAction(email) {
    return { type: types_1.AUTH_ACTION_TYPES.RESEND_CONFIRMATION_CODE, email };
}
exports.resendConfirmationCodeAction = resendConfirmationCodeAction;
function signInAction(email, password) {
    return { type: types_1.AUTH_ACTION_TYPES.SIGN_IN, email, password };
}
exports.signInAction = signInAction;
function signOutAction() {
    return { type: types_1.AUTH_ACTION_TYPES.SIGN_OUT };
}
exports.signOutAction = signOutAction;
function forgotPasswordAction(email) {
    return { type: types_1.AUTH_ACTION_TYPES.FORGOT_PASSWORD, email };
}
exports.forgotPasswordAction = forgotPasswordAction;
function forgotPasswordSubmitAction(code, newPassword) {
    return { type: types_1.AUTH_ACTION_TYPES.FORGOT_PASSWORD_SUBMIT, code, newPassword };
}
exports.forgotPasswordSubmitAction = forgotPasswordSubmitAction;
function changePasswordAction(oldPassword, newPassword) {
    return { type: types_1.AUTH_ACTION_TYPES.CHANGE_PASSWORD, oldPassword, newPassword };
}
exports.changePasswordAction = changePasswordAction;
function changeAttributesAction(name, email) {
    return { type: types_1.AUTH_ACTION_TYPES.CHANGE_ATTRIBUTES, name, email };
}
exports.changeAttributesAction = changeAttributesAction;
