"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const creators_1 = require("./actions/creators");
function authDispatches(dispatch) {
    return {
        signUp: (user) => dispatch(creators_1.signUpAction(Object.assign({}, user))),
        confirmSignUp: (confirmationCode) => dispatch(creators_1.confirmSignUpAction(confirmationCode)),
        resendConfirmationCode: (email) => dispatch(creators_1.resendConfirmationCodeAction(email)),
        signIn: (email, password) => dispatch(creators_1.signInAction(email, password)),
        signOut: () => dispatch(creators_1.signOutAction()),
        forgotPassword: (email) => dispatch(creators_1.forgotPasswordAction(email)),
        forgotPasswordSubmit: (code, newPassword) => dispatch(creators_1.forgotPasswordSubmitAction(code, newPassword)),
        changePassword: (oldPassword, newPassword) => dispatch(creators_1.changePasswordAction(oldPassword, newPassword)),
        changeAttributes: (name, email) => dispatch(creators_1.changeAttributesAction(name, email)),
    };
}
exports.default = authDispatches;
