"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const redux_observable_1 = require("redux-observable");
const operators_1 = require("rxjs/operators");
const Observable_1 = require("rxjs/Observable");
require("rxjs/add/observable/from");
require("rxjs/add/observable/of");
require("rxjs/add/operator/mergeMap");
require("rxjs/add/operator/catch");
const AuthService_1 = __importDefault(require("../../../AuthService"));
const types_1 = require("../../../actions/types");
const signIn = (action$, state$) => action$.pipe(redux_observable_1.ofType(types_1.AUTH_ACTION_TYPES.SIGN_IN), operators_1.switchMap(action => {
    const { email, password } = action;
    return AuthService_1.default.signIn(email, password).mergeMap(response => {
        if (response.challengeName === 'NEW_PASSWORD_REQUIRED') {
            return Observable_1.Observable.of({ type: types_1.AUTH_ACTION_TYPES.NEW_PASSWORD_REQUIRED, response });
        }
        return Observable_1.Observable.of({ type: types_1.AUTH_ACTION_TYPES.SIGN_IN_SUCCESSFUL, response });
    }).catch(error => {
        if (error.code === 'UserNotConfirmedException') {
            return Observable_1.Observable.of({ type: types_1.AUTH_ACTION_TYPES.USER_NOT_CONFIRMED, error });
        }
        return Observable_1.Observable.of({ type: types_1.AUTH_ACTION_TYPES.SIGN_IN_FAILED, error });
    });
}));
exports.default = signIn;
