"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const redux_observable_1 = require("redux-observable");
const operators_1 = require("rxjs/operators");
const Observable_1 = require("rxjs/Observable");
require("rxjs/add/observable/from");
require("rxjs/add/observable/of");
require("rxjs/add/operator/mergeMap");
require("rxjs/add/operator/catch");
const types_1 = require("../../actions/types");
const AuthService_1 = __importDefault(require("../../AuthService"));
const signOut = (action$, state$) => action$.pipe(redux_observable_1.ofType(types_1.AUTH_ACTION_TYPES.SIGN_OUT), operators_1.switchMap(() => AuthService_1.default.signOut()
    .mergeMap(response => Observable_1.Observable.of({ type: types_1.AUTH_ACTION_TYPES.SIGN_OUT_SUCCESSFUL, response })).catch(error => Observable_1.Observable.of({ type: types_1.AUTH_ACTION_TYPES.SIGN_OUT_FAILED, error }))));
exports.default = signOut;
