"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const redux_observable_1 = require("redux-observable");
const operators_1 = require("rxjs/operators");
const Observable_1 = require("rxjs/Observable");
require("rxjs/add/observable/from");
require("rxjs/add/observable/of");
require("rxjs/add/operator/mergeMap");
require("rxjs/add/operator/catch");
const types_1 = require("../../../actions/types");
const AuthService_1 = __importDefault(require("../../../AuthService"));
const confirmSignup = (action$, state$) => action$.pipe(redux_observable_1.ofType(types_1.AUTH_ACTION_TYPES.CONFIRM_SIGN_UP), operators_1.switchMap((action) => AuthService_1.default.confirmSignUp(state$.value.authReducer.email, action.confirmationCode).mergeMap(response => {
    return Observable_1.Observable.of({ type: types_1.AUTH_ACTION_TYPES.SIGN_UP_SUCCESSFUL, response });
}).catch(error => {
    if (error.code === 'ExpiredCodeException') {
        return Observable_1.Observable.of({ type: types_1.AUTH_ACTION_TYPES.RESEND_CONFIRMATION_CODE_ERROR, error });
    }
    else {
        return Observable_1.Observable.of({ type: types_1.AUTH_ACTION_TYPES.SIGN_UP_FAILED, error });
    }
})));
exports.default = confirmSignup;
