import newPasswordRequired from './signIn/newPasswordRequired'
import signIn from './signIn/signIn'
import signOut from './signOut'
import confirmSignup from './signUp/confirmSignUp'
import resendConfirmationCode from './signUp/resendConfirmationCode'
import signUp from './signUp/signUp'
import signUpSuccessfulSignIn from './signUp/signUpSuccessfulSignIn'
import forgotPassword from './password/forgotPassword'
import forgotPasswordSubmit from './password/forgotPasswordSubmit'
import changePassword from './password/changePassword'
import changeAttributes from './changeAttributes'
import { combineEpics } from 'redux-observable'

export const authEpics = combineEpics(
    signUp,
    confirmSignup,
    resendConfirmationCode,
    signUpSuccessfulSignIn,

    signIn,
    newPasswordRequired,

    signOut,
    
    forgotPassword, 
    forgotPasswordSubmit,
    changePassword,
    
    changeAttributes
)