import { ofType } from 'redux-observable'
import { switchMap } from 'rxjs/operators'
import { Observable } from 'rxjs/Observable'
import 'rxjs/add/observable/from'
import 'rxjs/add/observable/of'
import 'rxjs/add/operator/mergeMap'
import 'rxjs/add/operator/catch'
import { AUTH_ACTION_TYPES } from '../../actions/types'
import AuthService from '../../AuthService'

const signOut = (action$, state$) =>
    action$.pipe(
        ofType(AUTH_ACTION_TYPES.SIGN_OUT),
        switchMap(() =>
            AuthService.signOut()
            .mergeMap(response => Observable.of(
                { type: AUTH_ACTION_TYPES.SIGN_OUT_SUCCESSFUL, response}
            )).catch(error => Observable.of(
                { type: AUTH_ACTION_TYPES.SIGN_OUT_FAILED, error}
            ))
        )
    )

export default signOut